package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class NutrientesProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaNutrientesProd = By.xpath("//span[text() = 'Parametrização » Planejamento » Nutrientes']");

    By produtoGrafite = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'GRAFITE']");
    By botaoAdicionar = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"1676047231159162615350\"]");
    By campoQuant = By.xpath("//div[@id=\"grid-16760472312755473546899\"]//div[@class=\"body-content\"]/div[1]//div[5]");
    By campoFonte = By.xpath("//div[@id=\"grid-16760472312755473546899\"]//div[@class=\"body-content\"]/div[1]//div[6]");

    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"1676047231326765255530\"]");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");

    By checkBob = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By nomeNutriente = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By quantNutriente = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTNUTRPROD\"]/span");
    By fonteNutriente = By.xpath("//div[@id=\"grid-16760472313943750148339\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSFONTNUTR\"]/span");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]//li[@data-zh-id=\"16760472313913403913408\"]");
    By campoProdutoInicial = By.id("NMPRODINI");
    By produtoInicial = By.xpath("//div[@data-zh-id=\"1676047231761490681385\"]//span[text() = '1 | MATERIA PRIMA']");
    By botaoPesquisarProdutoFinal = By.xpath("//div[@id=\"NMPRODFIN\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurarProdutoFinal = By.xpath("//li[@class='float-action expandable fix-position-bottom opened']//input[@placeholder=\"Procurar\"]");
    By produtoFinal = By.xpath("//div[@data-zh-field-name=\"CDARVPROD\"]//span[text() = '7.02.1.1.10.002.00']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioNutrientes = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto']");
    By relatorioOrdemCrescente = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto (Ordem Crescente)']");
    By relatorioOrdemDescrescente = By.xpath("//div[@data-zh-id=\"1676047231126036909384\"]//li[text() = 'Nutrientes por Produto (Ordem Decrescente)']");

    By todosNutrientes = By.xpath("//label[@for=\"zh-checkbox-CHECKBOXNUTRIENTES\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoNutrientes = By.id("NMNUTRIENTE");
    By nutrienteVitaminaC = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA C']");
    By nutrienteVitaminaK = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA K']");

    //nutrientes encontrados no container dos nutrientes, após os mesmos serem seleionados para geração do relatório
    By primeiroNutrienteContainer = By.xpath("//div[@id=\"NMNUTRIENTE\"]//div[@class=\"zh-options-container\"]/span[1]");
    By segundoNutrienteContainer = By.xpath("//div[@id=\"NMNUTRIENTE\"]//div[@class=\"zh-options-container\"]/span[2]");

    By ordenacaoCodigo = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-ORDENACAO\"]//label[@for=\"radio-ORDENACAO-0\"]/div");
    By ordenacaoAlfabetica = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-ORDENACAO\"]//label[@for=\"radio-ORDENACAO-1\"]/div");
    By radioOrdenacaoCodigo = By.id("radio-ORDENACAO-0");
    By radioOrdenacaoAlfabetica = By.id("radio-ORDENACAO-1");

    By campoNivel = By.xpath("//div[@data-zh-id=\"1676047231978155531400\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By campoNivelSomenteParaLeitura = By.xpath("//div[@data-zh-id=\"1676047231978155531400\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\" and @readonly=\"readonly\"]");

    By mensagemCantoSuperiorDireito = By.xpath("//ul[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"1676047231761490681385\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"16760472313192712788389\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNutrientes = By.xpath("//div[@data-zh-id=\"16760472313241741951393\"]//div[@class=\"zh-validation\"]/span");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@class='popup-container']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes por Produto");
        click(opcaoTelaNutrientesProd);
    }

    public void adicionar() {
        tempo();
        tempo();
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-16760472313207956382337 > div.grid-vertical-scroll-control\").scrollBy(0, 300)");
        click(produtoGrafite);
        click(botaoAdicionar);
        tempo();
        tempo();
        WebElement quantidade = driver.findElement(campoQuant);
        Actions actions = new Actions(driver);
        actions.moveToElement(quantidade).click();
        actions.sendKeys(quantidade, Keys.BACK_SPACE);
        actions.sendKeys(quantidade, "32").build().perform();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        actions.sendKeys(driver.findElement(campoFonte), "Auto").build().perform();

        click(botaoSalvarAlteracoes);
        tempo();

        String nomeNutri = getText(nomeNutriente);
        String quantNutri = getText(quantNutriente);
        String fonteNutri = getText(fonteNutriente);
        Assert.assertEquals(nomeNutri, "VITAMINA A", "Verificação do nome do nutriente");
        Assert.assertEquals(quantNutri, "32,00000", "Varificação da quantidade do nutriente");
        Assert.assertEquals(fonteNutri, "Auto", "Varificação da fonte do nutriente");
    }

    public void editar() {
        tempo();
        WebElement element = driver.findElement(quantNutriente);
        WebElement font = driver.findElement(fonteNutriente);
        Actions actions = new Actions(driver);
        actions.moveToElement(element).click();
        actions.sendKeys(element, Keys.BACK_SPACE);
        actions.sendKeys(element, "35,4");
        actions.sendKeys(element, Keys.ENTER).build().perform();

        tempo();
        actions.sendKeys(font, Keys.BACK_SPACE);
        actions.sendKeys(font, "Automação").build().perform();

        click(botaoSalvarAlteracoes);
        tempo();
        String quant = getText(quantNutriente);
        String fonte = getText(fonteNutriente);
        Assert.assertEquals(quant, "35,40000", "Verificação da quantidade após edição");
        Assert.assertEquals(fonte, "Automação", "Verificação da fonte após a edição");
    }

    public void excluir() {
        tempo();
        click(checkBob);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, "Deletar o(s) registro(s)?", "Verificação mensagem alerta da exclusão");
        click(botaoSim);

        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagemExcluidoSucesso, mensagemEsperada, "Verificar se após excluir o nutriente, aparece a mensagem de excluído com sucesso no canto superior direito da tela ");
    }

    public void relatorio(String nomeRelatorio) {

        click(botaoRelatorio);

        if (nomeRelatorio == "Nutrientes por Produto") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioNutrientes);
        } else if (nomeRelatorio == "Nutrientes por Produto (Ordem Crescente)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOrdemCrescente);
        } else if (nomeRelatorio == "Nutrientes por Produto (Ordem Decrescente)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioOrdemDescrescente);
        }

        clicarCampoSelecionarValor(campoProdutoInicial, produtoInicial);
        click(botaoPesquisarProdutoFinal);
        sendKeys(campoProcurarProdutoFinal, "LAMINA LARGA CIS LA-L10 207.5800 (10UN)");
        click(produtoFinal);

        click(botaoConfirmar);
        click(tipoPdf);
        click(botaoConfirmar);
    }

    public void verificarCampoNutriente() {
        click(botaoRelatorio);
        click(todosNutrientes);
        click(campoNutrientes);
        click(nutrienteVitaminaC);
        click(nutrienteVitaminaK);
        click(botaoOk);

        //nutrientes encontrados no container após a seleção
        String encPrimeiroNutriente = getText(primeiroNutrienteContainer);
        String encSegundoNutriente = getText(segundoNutrienteContainer);

        //nutrientes esperados no container
        String expPrimeiro = "×VITAMINA C";
        String expSegundo = "×VITAMINA K";
        Assert.assertEquals(encPrimeiroNutriente, expPrimeiro, "Verificação do primeiro nutriente encontrado no container dos nutrientes, após a seleção para geração do relatório");
        Assert.assertEquals(encSegundoNutriente, expSegundo, "Verificação do segundo nutriente encontrado no container dos nutrientes, após a seleção para geração do relatório");
    }

    public void verificarCamposObrigatorios() {
        click(botaoRelatorio);
        click(todosNutrientes);
        tempo();
        click(botaoConfirmar);

        //mensagem de campo obrigatório nos campos
        String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
        String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
        String nutrientes = getText(mensagemObrigatorioNutrientes);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto inicial");
        Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo produto final");
        Assert.assertEquals(nutrientes, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo nutrientes");
    }

    public void verificarOrdenacao() {
        boolean codigo = returnIfElementIsSelected(radioOrdenacaoCodigo);
        Assert.assertEquals(codigo, true, "Verificar se por padrão a ordenação por código já vem selecionado");

        click(ordenacaoAlfabetica);
        boolean alfabetica = returnIfElementIsSelected(radioOrdenacaoAlfabetica);
        Assert.assertEquals(alfabetica, true, "Verificar se após clicar na ordenação alfabética, a mesma passa a estar selecionada");
    }

    public void verificarCampoNivel() {
        click(ordenacaoCodigo);
        boolean campoNivelSomenteLeituraExiste = returnIfElementExists(campoNivelSomenteParaLeitura);
        Assert.assertEquals(campoNivelSomenteLeituraExiste, true, "Verificar se com a ordenação código, o campo nível está habilitado somente para leitura");

        click(ordenacaoAlfabetica);
        boolean campoNivelParaSelecionarExiste = returnIfElementExists(campoNivel);
        Assert.assertEquals(campoNivelParaSelecionarExiste, true, "Verificar se enquanto a ordenação alfabética está selecionada, o campo nível está habilitado para selecionar");

        click(campoNivel);
        for (int nivel=0; nivel<=5; nivel++) {
            By nivelOrdenacao = By.xpath("//div[@data-zh-id=\"1676047231978155531400\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = '" + nivel + "']");
            boolean nivelExiste = returnIfElementExists(nivelOrdenacao);
            Assert.assertEquals(nivelExiste, true, "Verificar se o nível " + nivel + " está presente na lista do campo nível");
        }
    }

}
