package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RequisicaoServicoAnaliticaFlows;
import com.javaseleniumtemplate.pages.RequisicaoServicoAnaliticaPage;
import org.testng.annotations.Test;

public class RequisicaoServicoAnaliticaTests extends TestBase {

    RequisicaoServicoAnaliticaPage requisicaoServicoAnaliticaPage;
    RequisicaoServicoAnaliticaFlows requisicaoServicoAnaliticaFlows;
    LoginFlows loginFlows;

//    Requisição Analítica (por Serviço)
//    Requisição Analítica (Turnos Por Serviço)
//    Requisição Analítica (por Grupo de Serviço)
//    Requisição Analítica (com Modo de Preparo)
//    Requisição Analítica (por Tipo de Prato/Prato)
//    Requisição Analítica (Produção)
//    Requisição Analítica (Produção por Grupo de Serviço)
//    Requisição Analítica (Produção Geral)


    @Test
    public void relatorioPorServico() {
        geracaoDoRelatorio("Requisição Analítica (por Serviço)");
    }

    @Test
    public void relatorioTurnosPorServico() {
        geracaoDoRelatorio("Requisição Analítica (Turnos Por Serviço)");
    }

    @Test
    public void relatorioGrupoDeServico() {
        geracaoDoRelatorio("Requisição Analítica (por Grupo de Serviço)");
    }

    @Test
    public void relatorioModoDePreparo() {
        geracaoDoRelatorio("Requisição Analítica (com Modo de Preparo)");
    }

    @Test
    public void relatorioTipoDePrato() {
        geracaoDoRelatorio("Requisição Analítica (por Tipo de Prato/Prato)");
    }

    @Test
    public void relatorioProducao() {
        geracaoDoRelatorio("Requisição Analítica (Produção)");
    }

    @Test
    public void relatorioProducaoPorGrupo() {
        geracaoDoRelatorio("Requisição Analítica (Produção por Grupo de Serviço)");
    }

    @Test
    public void relatorioProducaoGeral() {
        geracaoDoRelatorio("Requisição Analítica (Produção Geral)");
    }


    //acessar a tela Requisição por Serviço Analítica
    //selecionar os relatórios
    //preecher as datas inicial e final
    //gerar o relatórios com a opção 'Todos' dos campos 'grupos de serviço' e 'serviço' selecionados
    //fechar a guia do relatório e atualizar a tela
    //selecionar novamente os relatório, preencher as datas inicial e final e também alguns 'grupos de serviço' e 'serviço' de forma manual
    //gerar o relatório e fechar a guia do relatório gerado
    public void geracaoDoRelatorio(String nomeRelatorio) {
        requisicaoServicoAnaliticaPage = new RequisicaoServicoAnaliticaPage();
        requisicaoServicoAnaliticaFlows = new RequisicaoServicoAnaliticaFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/05/2023";
        String dataFinal = "31/05/2023";

        loginFlows.efetuarLogin();
        requisicaoServicoAnaliticaFlows.navegateRequisicaoServicoAnalitica();
        requisicaoServicoAnaliticaPage.selecionaRelatorio(nomeRelatorio);
        requisicaoServicoAnaliticaPage.preencherDatas(dataInicial, dataFinal);
        requisicaoServicoAnaliticaPage.geraRelatorio();
        requisicaoServicoAnaliticaPage.refresh();
        requisicaoServicoAnaliticaPage.selecionaRelatorio(nomeRelatorio);
        requisicaoServicoAnaliticaPage.preencherDatas(dataInicial, dataFinal);
        requisicaoServicoAnaliticaPage.selecionarGrupoServico();
        requisicaoServicoAnaliticaPage.selecionarServico();
        requisicaoServicoAnaliticaPage.preencherPercentualAcressimo();
        requisicaoServicoAnaliticaPage.geraRelatorio();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //acessar a tela Requisição por Serviço Analítica
    //verificar se os check-box dos campos: quebra de página, imprimir linhas em branco, arredondar qtde. do produtos, cardápio, consumo fixo e consumo per capita
    //verificar se quando carrega a tela alguns já vem selecionados ou não e quando clicar nos mesmo os que não estavam selecionados passam a estar e os que estão passam a não estar selecionados
    //recarregar a página e verificar se quando o check-box de 'imprimir linhas em branco' não está selecionado o campo para inserir a quantidade de linhas está desabilitado
    //selecionar o check-box de 'imprimir linhas em branco' e verificar se o campo passa à estar habilitado e inserir uma quantidade de linhas e verificar se o valor fica salvo corretamente
    //verificar todos os campos obrigatórios da tela
    //verificar se a ordenação 'código' por padrão já vem selecioanada e a 'alfabética por nível' não. Quando a alfabética por nível não está selecionada o campo 'nível' fica desabilitado
    //selecionar a ordenação 'alfabética por nível', verificar se o campo de 'nível' ficou habilita, selecionar e nível e ver se o mesmo foi selecionado corretamente
    @Test
    public void testesComplementares() {
        requisicaoServicoAnaliticaPage = new RequisicaoServicoAnaliticaPage();
        requisicaoServicoAnaliticaFlows = new RequisicaoServicoAnaliticaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoServicoAnaliticaFlows.navegateRequisicaoServicoAnalitica();
        requisicaoServicoAnaliticaPage.verificarCheckBoxs();
        requisicaoServicoAnaliticaPage.refresh();
        requisicaoServicoAnaliticaPage.verificarQuantLinhasBranco();
        requisicaoServicoAnaliticaPage.verificarCampoObrigatorios();
        requisicaoServicoAnaliticaPage.verificarOrdenacao();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


}
